unit testIniFileOtherUnit;

interface

uses
  Windows,
  Classes,
  SysUtils,
  IniFiles,
  Dialogs,
  Math,

  FileUnit,
//  StringUnitHeavy,
  AnsiStringFileUnit,
  ExePathUnit,
  SystemUnit,
  XPtest;

procedure testIniFileOther;

procedure MakeIniFileDeleteKey;
function ResultIniFileDeleteKey: String;
function ResultIniFileEraseSection: String;

implementation

uses Unit1, AccessIniFile, IniFilEX, NkMemIniFile;

procedure MakeIniFileDeleteKey;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('');
  StrList.Add('[]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add(']');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[Option1]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.Add('[Option1]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  StrList.SaveToFile(ChangeFileExt(ParamStr(0), '.ini'));
  StrList.Free;
end;

function ResultIniFileDeleteKey: String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('');
  StrList.Add('[]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add(']');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[Option1]');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.Add('[Option1]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  Result := StrList.Text;
  StrList.Free;
end;


procedure testIniFileDeleteKey(Ini: TCustomIniFile);
var
  BeforeWriteString: String;
  AfterWriteString: String;
begin
  with UnitTest do begin
  BeforeWriteString := LoadStringFromFile(AppIniFilePath);
  Ini.DeleteKey('Option1', 'Name1');
  Ini.UpdateFile;
  Ini.Free;

  BeforeWriteString := ResultIniFileDeleteKey;
  AfterWriteString  := LoadStringFromFile(AppIniFilePath);
  Form1.Memo1.Text := BeforeWriteString;
  Form1.Memo2.Text := AfterWriteString;
  Check(BeforeWriteString, AfterWriteString);
  end;
end;

function ResultIniFileEraseSection: String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('');
  StrList.Add('[]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add(']');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('');
  StrList.Add('[Option1]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  Result := StrList.Text;
  StrList.Free;
end;

procedure testIniFileEraseSection(Ini: TCustomIniFile);
var
  BeforeWriteString: String;
  AfterWriteString: String;
begin
  with UnitTest do begin
  BeforeWriteString := LoadStringFromFile(AppIniFilePath);
  Ini.EraseSection('Option1');
  Ini.EraseSection('Option2');
  Ini.UpdateFile;
  Ini.Free;

  BeforeWriteString := ResultIniFileEraseSection;
  AfterWriteString  := LoadStringFromFile(AppIniFilePath);
  Form1.Memo1.Text := BeforeWriteString;
  Form1.Memo2.Text := AfterWriteString;
  Check(BeforeWriteString, AfterWriteString);
  end;
end;


procedure testIniFileOther;
begin
  UnitTest.Initialize;  UnitTest.WriteLog(TIniFile.ClassName);
  MakeIniFileDeleteKey;   testIniFileDeleteKey(TIniFile.Create(AppIniFilePath));
  MakeIniFileDeleteKey;   testIniFileEraseSection(TIniFile.Create(AppIniFilePath));
  if 1 <= UnitTest.ErrorCount then
    if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
         TIniFile.ClassName, MB_YESNO) = IDYES then
    begin
      DoubleMemoCheck;
      Exit;
    end;

  UnitTest.Initialize;  UnitTest.WriteLog(TAccessIniFile.ClassName);
  MakeIniFileDeleteKey;   testIniFileDeleteKey(TAccessIniFile.Create(AppIniFilePath));
  MakeIniFileDeleteKey;   testIniFileEraseSection(TAccessIniFile.Create(AppIniFilePath));
  if 1 <= UnitTest.ErrorCount then
    if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
         TAccessIniFile.ClassName, MB_YESNO) = IDYES then
    begin
      DoubleMemoCheck;
      Exit;
    end;

//  UnitTest.Initialize;  UnitTest.WriteLog(TMemIniFile.ClassName);
//  MakeIniFileDeleteKey;   testIniFileDeleteKey(TMemIniFile.Create(AppIniFilePath));
//  MakeIniFileDeleteKey;   testIniFileEraseSection(TMemIniFile.Create(AppIniFilePath));
//  if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
//       TMemIniFile.ClassName, MB_YESNO) = IDYES then
//  begin
//    DoubleMemoCheck;
//    Exit;
//  end;
//
//  UnitTest.Initialize;  UnitTest.WriteLog(TNkMemIniFile.ClassName);
//  MakeIniFileDeleteKey;   testIniFileDeleteKey(TNkMemIniFile.Create(AppIniFilePath));
//  MakeIniFileDeleteKey;   testIniFileEraseSection(TNkMemIniFile.Create(AppIniFilePath));
//  if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
//       TNkMemIniFile.ClassName, MB_YESNO) = IDYES then
//  begin
//    DoubleMemoCheck;
//    Exit;
//  end;
//
//  UnitTest.Initialize;  UnitTest.WriteLog(TIniFileEX.ClassName);
//  MakeIniFileDeleteKey;   testIniFileDeleteKey(TIniFileEX.Create(AppIniFilePath));
//  MakeIniFileDeleteKey;   testIniFileEraseSection(TIniFileEX.Create(AppIniFilePath));
//  if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
//       TIniFileEX.ClassName, MB_YESNO) = IDYES then
//  begin
//    DoubleMemoCheck;
//    Exit;
//  end;

(*-------------------------------
DeleteKey
> EZNVꍇA
>   擪ZNVΏۂɂȂȂƂmF
	testIniFileDeleteKeyŊmF

> EZNVڂɉeȂƂmF
	testIniFileDeleteKeyŊmF

EraceSection
> EZNVꍇA
>   擪ZNVΏۂɂȂȂƂmFB
    testIniFileEraseSectionŊmF

> EZNVłName=ValuenȊO̍s͎c邱ƂmF
    testIniFileEraseSectionŊmF
    ZNVōŌ̕gĂ邱Ƃ킩

//-------------------------------*)

end;

end.
