unit testIniSectionsUnit;

interface

uses
  Windows,
  Classes,
  SysUtils,
  IniFiles,
  Dialogs,
  Math,

  FileUnit,
//  StringUnitHeavy,
  AnsiStringFileUnit,
  ExePathUnit,
  SystemUnit,
  XPtest;

procedure testIniSections;


implementation

uses Unit1, AccessIniFile, IniFilEX, NkMemIniFile, testIniFileOtherUnit,
  testIniFileReadStringUnit, testIniWriteStringUnit;

function GetReadSectionValues(Sec: string; Ini: TCustomIniFile): String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create; try
  Ini.ReadSectionValues(Sec, StrList);
  Result := StrList.Text;
  finally StrList.Free; end;
end;


procedure testIniSections;

var
  Ini: TIniFile;
  AcIni: TAccessIniFile;

    function testLoop: Boolean;
    var
      i: Integer;
      Sections: TStringList;
    begin
      Result := True;
      with UnitTest do
      with Form1 do begin

      Initialize;
      Sections := TStringList.Create;
      Ini := TIniFile.Create(AppIniFilePath);
      AcIni := TAccessIniFile.Create(AppIniFilePath);

      Ini.ReadSections(Sections);
      Memo1.Text := Sections.Text;
      AcIni.ReadSections(Memo2.Lines);
      Check(Memo1.Text, Memo2.Text);
      for i := 0 to Sections.Count - 1 do
      begin
        Memo1.Text := GetReadSectionValues(Sections[i], Ini);
        Memo2.Text := GetReadSectionValues(Sections[i], AcIni);
        Check(Memo1.Text, Memo2.Text);
      end;
      Sections.Free;
      Ini.Free;
      AcIni.Free;

      if 1 <= UnitTest.ErrorCount then
      begin
        if AppMsgBox('~܂'+#13+ UnitTest.Finalize,
             '', MB_YESNO) = IDYES then
        begin
          DoubleMemoCheck;
          Result := False;
        end;
      end;
      end;
    end;


begin
  MakeNormalIniFile;
  if testLoop=False then Exit;
  MakeDuplicationSectionIniFile;
  if testLoop=False then Exit;
  MakeIndentIniFile;
  if testLoop=False then Exit;
  MakeCommentIniFile;
  if testLoop=False then Exit;
  MakeTrimValueIniFile;
  if testLoop=False then Exit;
  MakeTrimSectionIdentIniFile;
  if testLoop=False then Exit;
  MakeIniFileHoldComment1;
  if testLoop=False then Exit;
  MakeIniFileHoldComment2;
  if testLoop=False then Exit;
  MakeIniFileHoldComment3;
  if testLoop=False then Exit;
  MakeIniFileHoldComment4;
  if testLoop=False then Exit;
  MakeIniFileSpaceTabSection;
  if testLoop=False then Exit;
  MakeIniFileEmptySection;
  if testLoop=False then Exit;
  MakeIniFileDeleteKey;
  if testLoop=False then Exit;

  SaveStringToFile(AppIniFilePath, ResultIniFile);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFile2);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFile3);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFile4);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFileSpaceTabSection);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFileEmptySection);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFileDeleteKey);
  if testLoop=False then Exit;
  SaveStringToFile(AppIniFilePath, ResultIniFileEraseSection);
  if testLoop=False then Exit;

end;

end.
